<template>
  <div class="drawable-upload">
    <label for="upload_image" class="upload-group">
      <input
        class="upload-input"
        type="file"
        name="upload_image"
        accept="image/*"
        @change="onUploadFile"
      />
      <button>
        <font-awesome-icon icon="camera" />
        <span>Chọn ảnh</span>
      </button>
    </label>
    <label class="upload-group">
      <button class="outline" @click="$emit('upload')">
        <font-awesome-icon icon="times-circle" />
        <span>Tôi không cần ảnh</span>
      </button>
    </label>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';

@Component
export default class DrawableUploadComponent extends Vue {
  protected onUploadFile(e) {
    if (e.target.files) {
      const file = e.target.files[0];
      if (file.size >= 2.5 * 1024 * 1024) {
        alert('Kích cỡ file phải nhỏ hơn 2.5 MB');
        return;
      }

      if (loadImage) {
        loadImage.parseMetaData(file, data => {
          let orientation = 0;

          if (data.exif) {
            orientation = data.exif.get('Orientation');
          }

          var loadingImage = loadImage(
            file,
            canvas => {
              //here's the base64 data result
              var base64data = canvas.toDataURL('image/jpeg');
              this.$emit('upload', base64data);
            },
            { canvas: true, orientation: orientation }
          );
        });
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.drawable-upload {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  width: 100%;

  button {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    background-color: $primary;
    color: white;
    border: none;
    font-size: 2vh;
    font-weight: bold;
    margin-bottom: 2vh;
    padding: 1.5vh 2vh;
    border-radius: 1vh;
    width: 100%;
    font-family: 'Montserrat', san-serif;

    &.outline {
      background-color: transparent;
      border: 1px solid white;
      color: white;
    }

    svg {
      height: 2vh;
      margin-right: 5px;
    }
  }

  .upload-group {
    position: relative;
    overflow: hidden;
    display: inline-block;
    width: 100%;

    input[type='file'] {
      position: absolute;
      left: 0;
      opacity: 0;
      top: 0;
      bottom: 0;
      width: 100%;
    }
  }
}

@include Orientation(Landscape) {
  .drawable-upload {
    .upload-group {
      width: 70%;
    }
  }
}
</style>